// dllmain.cpp : Defines the entry point for the DLL application.
#define WIN32_LEAN_AND_MEAN
#include <windows.h>
#include <shellapi.h>
#include <shlobj_core.h>
#include <winternl.h>
#include <iostream>
#include <tlhelp32.h>
#include <psapi.h>

extern "C" _declspec(dllexport) void launc() { return; }


static HMODULE hExe = nullptr;

DWORD_PTR GetProcessBaseAddress(HANDLE hprocess)
{
    DWORD_PTR   baseAddress = 0;
    HANDLE      processHandle = hprocess;
    HMODULE* moduleArray;
    LPBYTE      moduleArrayBytes;
    DWORD       bytesRequired;

    if (processHandle)
    {
        if (EnumProcessModules(processHandle, NULL, 0, &bytesRequired))
        {
            if (bytesRequired)
            {
                moduleArrayBytes = (LPBYTE)LocalAlloc(LPTR, bytesRequired);

                if (moduleArrayBytes)
                {
                    unsigned int moduleCount;

                    moduleCount = bytesRequired / sizeof(HMODULE);
                    moduleArray = (HMODULE*)moduleArrayBytes;

                    if (EnumProcessModules(processHandle, moduleArray, bytesRequired, &bytesRequired))
                    {
                        baseAddress = (DWORD_PTR)moduleArray[0];
                    }

                    LocalFree(moduleArrayBytes);
                }
            }
        }
    }

    return baseAddress;
}
bool LaunchRemoteProcess(CHAR* SCFile, CHAR* SCStartIn, CHAR* GameProcessFile, CHAR* GameStartIn, CHAR* GameCMDLine)
{
    STARTUPINFOA info = { sizeof(info) };
    PROCESS_INFORMATION processInfo;
    return CreateProcessA(SCFile, NULL, NULL, NULL, NULL, NULL, NULL, SCStartIn, &info, &processInfo);
}
bool IsStartedFromLauncher(CHAR* FullLPath)
{
    DWORD CurrentPID = GetCurrentProcessId();
    bool Return = false;
    CHAR OutFoundPath[1024] = { 0 };

    HANDLE hSnapShot = CreateToolhelp32Snapshot(TH32CS_SNAPPROCESS, 0);
    PROCESSENTRY32 pe = { 0 };
    pe.dwSize = sizeof(PROCESSENTRY32);

    if (hSnapShot != INVALID_HANDLE_VALUE) {
        if (Process32First(hSnapShot, &pe)) {
            do {
                if (pe.th32ProcessID == CurrentPID) {
                    HANDLE hProcess = OpenProcess(PROCESS_QUERY_INFORMATION | PROCESS_VM_READ, FALSE, pe.th32ParentProcessID);
                    if (hProcess) {
                        DWORD n = GetModuleFileNameExA(hProcess, (HMODULE)GetProcessBaseAddress(hProcess), OutFoundPath, MAX_PATH);
                        if (n > 0)
                        {
                            if (lstrcmpA(OutFoundPath, FullLPath) == 0) {
                                Return = true;
                            }
                        }
                        CloseHandle(hProcess);
                    }
                    break;
                }
            } while (Process32Next(hSnapShot, &pe));
        }
        CloseHandle(hSnapShot);
    }
    else {
        MessageBoxA(0, "Sorry, something went wrong, the handle for retrieving the running processes list can not be created!", "", MB_ICONERROR);
        TerminateProcess(GetCurrentProcess(), 0);
    }
    return Return;
}

#include <detours.h>
#ifdef MP3

HMODULE (WINAPI *Real_LoadLibraryExA)(
  LPCSTR lpLibFileName,
  HANDLE hFile,
  DWORD  dwFlags
) = LoadLibraryExA;

static bool hasEnding (std::string const &fullString, std::string const &ending) {
    if (fullString.length() >= ending.length()) {
        return (0 == fullString.compare (fullString.length() - ending.length(), ending.length(), ending));
    } else {
        return false;
    }
}

HMODULE WINAPI Mine_LoadLibraryExA(
  LPCSTR lpLibFileName,
  HANDLE hFile,
  DWORD  dwFlags
) {
    if (hasEnding(lpLibFileName, "socialclub.dll")) {
        return Real_LoadLibraryExA("socialclub.dll", hFile, dwFlags);
    } else {
        return Real_LoadLibraryExA(lpLibFileName, hFile, dwFlags);
    }
}

void Care()
{
    DetourTransactionBegin();
    DetourUpdateThread( GetCurrentThread() );
    DetourAttach( &(PVOID &)Real_LoadLibraryExA, Mine_LoadLibraryExA );
    DetourTransactionCommit();
}

#else

static bool hasEnding (std::wstring const &fullString, std::wstring const &ending) {
    if (fullString.length() >= ending.length()) {
        return (0 == fullString.compare (fullString.length() - ending.length(), ending.length(), ending));
    } else {
        return false;
    }
}

#ifdef GTAIV

HMODULE (WINAPI *Real_LoadLibraryExW)(
  LPCWSTR lpLibFileName,
  HANDLE hFile,
  DWORD  dwFlags
) = LoadLibraryExW;

DWORD (WINAPI *Real_GetFileAttributesW)(
  LPCWSTR lpLibFileName
) = GetFileAttributesW;


HMODULE WINAPI Mine_LoadLibraryExW(
  LPCWSTR lpLibFileName,
  HANDLE hFile,
  DWORD  dwFlags
) {
    //PRINT_DEBUG("Mine_LoadLibraryExW %ls\n", lpLibFileName);
    if (hasEnding(lpLibFileName, L"socialclub.dll")) {
        return Real_LoadLibraryExW(L"socialclub.dll", hFile, dwFlags);
    } else {
        return Real_LoadLibraryExW(lpLibFileName, hFile, dwFlags);
    }
}

DWORD WINAPI Mine_GetFileAttributesW(LPCWSTR lpFileName)
{
    if (hasEnding(lpFileName, L"socialclub.dll")) {
        memcpy((void *)lpFileName, L"orig_socialclub.dll", sizeof(L"orig_socialclub.dll"));
    }

    return Real_GetFileAttributesW(lpFileName);
}

void Care()
{
    DetourTransactionBegin();
    DetourUpdateThread( GetCurrentThread() );
    DetourAttach( &(PVOID &)Real_LoadLibraryExW, Mine_LoadLibraryExW );
    DetourAttach( &(PVOID &)Real_GetFileAttributesW, Mine_GetFileAttributesW );
    DetourTransactionCommit();
}

#else

HMODULE (WINAPI *Real_LoadLibraryExW)(
  LPCWSTR lpLibFileName,
  HANDLE hFile,
  DWORD  dwFlags
) = LoadLibraryExW;

DWORD (WINAPI *Real_GetFileAttributesW)(
  LPCWSTR lpLibFileName
) = GetFileAttributesW;


HMODULE WINAPI Mine_LoadLibraryExW(
  LPCWSTR lpLibFileName,
  HANDLE hFile,
  DWORD  dwFlags
) {
    //PRINT_DEBUG("Mine_LoadLibraryExW %ls\n", lpLibFileName);
    if (hasEnding(lpLibFileName, L"socialclub.dll")) {
        return Real_LoadLibraryExW(L"socialclub.dll", hFile, dwFlags);
    } else {
        return Real_LoadLibraryExW(lpLibFileName, hFile, dwFlags);
    }
}

DWORD WINAPI Mine_GetFileAttributesW(LPCWSTR lpFileName)
{
    if (hasEnding(lpFileName, L"socialclub.dll")) {
        memcpy((void *)lpFileName, L"orig_socialclub.dll", sizeof(L"orig_socialclub.dll"));
    }

    return Real_GetFileAttributesW(lpFileName);
}

void Care()
{
    DetourTransactionBegin();
    DetourUpdateThread( GetCurrentThread() );
    DetourAttach( &(PVOID &)Real_LoadLibraryExW, Mine_LoadLibraryExW );
    DetourAttach( &(PVOID &)Real_GetFileAttributesW, Mine_GetFileAttributesW );
    DetourTransactionCommit();

}

#endif
#endif

void Init()
{
    char SCLauncher[MAX_PATH] = { 0 };
    char SCEmu[MAX_PATH] = { 0 };
    char GameFileExe[MAX_PATH] = { 0 };
    char StartIn[MAX_PATH] = { 0 };
    char Language[200] = { 0 };

    int Length = GetModuleFileNameA(hExe, GameFileExe, MAX_PATH);
    lstrcpyA(SCLauncher, GameFileExe);
    lstrcpyA(SCEmu, GameFileExe);
    lstrcpyA(StartIn, GameFileExe);

    for (int i = Length; i > 0; i--) {
        if (GameFileExe[i] == '\\') {
#ifndef MP3
#ifdef GTAIV
            lstrcpyA(&SCLauncher[i], "\\Launcher.exe");
#else
            lstrcpyA(&SCLauncher[i], "\\PlayGTAV.exe");
#endif
#endif
            lstrcpyA(&SCEmu[i], "\\socialclub.dll");
            StartIn[i] = 0;
            break;
        }
    }

    if (GetFileAttributesA(SCEmu) == INVALID_FILE_ATTRIBUTES) {
        MessageBoxA(0, "socialclub.dll not found.", "", MB_ICONERROR);
        TerminateProcess(GetCurrentProcess(), 0);
    }

#ifndef MP3
#ifndef GTAIV
    if (GetFileAttributesA(SCLauncher) == INVALID_FILE_ATTRIBUTES) {
        char msg[256];
        snprintf(msg, sizeof(msg), "%s not found.", SCLauncher);
        MessageBoxA(0, msg, "", MB_ICONERROR);
        TerminateProcess(GetCurrentProcess(), 0);
    }

    if (!IsStartedFromLauncher(SCLauncher)) {
        if (!LaunchRemoteProcess(SCLauncher, StartIn, GameFileExe, StartIn, GetCommandLineA())) {
            MessageBoxA(0, "Couldn't start the game.", "", MB_ICONERROR);
        }
        TerminateProcess(GetCurrentProcess(), 0);
    }
#endif
#endif
    Care();
}
BOOL APIENTRY DllMain(HMODULE hModule, DWORD  ul_reason_for_call, LPVOID lpReserved)
{
    if (ul_reason_for_call == DLL_PROCESS_ATTACH)
    {
        hExe = GetModuleHandleA(nullptr);
        if (hExe)
        {
            Init();
        }
        else
        {
            MessageBoxA(0, "Falied to retrieve the main module, game will exit.", "", MB_ICONERROR);
            TerminateProcess(GetCurrentProcess(), 0);
        }
    }
    return TRUE;
}

